import _tunepimp

# TODO
#   Document - write doc strings as needed
#              how does the python interface differ from the C interface?
#   Exceptions - functions that return errors should throw exceptions
#   Unhandled case - handle result_t casting cases   

# TPCallBackEnum values used for GetNotification
eFileAdded = 0;
eFileChanged = 1;
eFileRemoved = 2;
eWriteTagsComplete = 3;

# TODO change these to exceptions
# TPError returned by WriteTags and GetResults
eOk                     = 0;
eTooManyTRMs            = 1;
eNoUserInfo             = 2;
eLookupError            = 3;
eSubmitError            = 4;
eInvalidIndex           = 5;
eInvalidObject          = 6;

# TPFileStatus
eUnrecognized           = 0;    # unrecognized
eRecognized             = 1;    # Recognized and previously saved
ePending                = 2;    # pending trm calculation
eTRMLookup              = 3;    # trm done, pending trm lookup
eTRMCollision           = 4;    # trm done, pending trm lookup
eFileLookup             = 5;    # trm done, no matches, pending file lookup
eUserSelection          = 6;    # file lookup done, needs user selection
eVerified               = 7;    # User verified, about to write changes to disk 
eSaved                  = 8;    # File was saved
eDeleted                = 9;    # to be deleted, waiting for refcount == 0
eError                  = 10;   # Error

# TPResultType
eNone                   = 0;
eArtistList             = 1;
eAlbumList              = 2;
eTrackList              = 3;
eMatchedTrack           = 4;

# TPAlbumType
eAlbumType_Album        = 0;
eAlbumType_Single       = 1;
eAlbumType_EP           = 2;
eAlbumType_Compilation  = 3;
eAlbumType_Soundtrack   = 4;
eAlbumType_Spokenword   = 5;
eAlbumType_Interview    = 6;
eAlbumType_Audiobook    = 7;
eAlbumType_Live         = 8;
eAlbumType_Remix        = 9;
eAlbumType_Other        = 10;
eAlbumType_Error        = 11;

# TPAlbumStatus
eAlbumStatus_Official   = 0;
eAlbumStatus_Promotion  = 1;
eAlbumStatus_Bootleg    = 2;

# TPThreadPriorityEnum;
eIdle                   = 0;
eLowest                 = 1;
eLow                    = 2;
eNormal                 = 3;
eHigh                   = 4;
eHigher                 = 5;
eTimeCritical           = 6;


def _swig_setattr(self,class_type,name,value):
    if (name == "this"):
        if isinstance(value, class_type):
            self.__dict__[name] = value.this
            if hasattr(value,"thisown"): self.__dict__["thisown"] = value.thisown
            del value.thisown
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    self.__dict__[name] = value

def _swig_getattr(self,class_type,name):
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError,name

import types
try:
    _object = types.ObjectType
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0
del types


class metadata(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, metadata, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, metadata, name)
    def __repr__(self):
        return "<C metadata instance at %s>" % (self.this,)
    __swig_setmethods__["artist"] = _tunepimp.metadata_artist_set
    __swig_getmethods__["artist"] = _tunepimp.metadata_artist_get
    if _newclass:artist = property(_tunepimp.metadata_artist_get, _tunepimp.metadata_artist_set)
    __swig_setmethods__["sortName"] = _tunepimp.metadata_sortName_set
    __swig_getmethods__["sortName"] = _tunepimp.metadata_sortName_get
    if _newclass:sortName = property(_tunepimp.metadata_sortName_get, _tunepimp.metadata_sortName_set)
    __swig_setmethods__["album"] = _tunepimp.metadata_album_set
    __swig_getmethods__["album"] = _tunepimp.metadata_album_get
    if _newclass:album = property(_tunepimp.metadata_album_get, _tunepimp.metadata_album_set)
    __swig_setmethods__["track"] = _tunepimp.metadata_track_set
    __swig_getmethods__["track"] = _tunepimp.metadata_track_get
    if _newclass:track = property(_tunepimp.metadata_track_get, _tunepimp.metadata_track_set)
    __swig_setmethods__["trackNum"] = _tunepimp.metadata_trackNum_set
    __swig_getmethods__["trackNum"] = _tunepimp.metadata_trackNum_get
    if _newclass:trackNum = property(_tunepimp.metadata_trackNum_get, _tunepimp.metadata_trackNum_set)
    __swig_setmethods__["variousArtist"] = _tunepimp.metadata_variousArtist_set
    __swig_getmethods__["variousArtist"] = _tunepimp.metadata_variousArtist_get
    if _newclass:variousArtist = property(_tunepimp.metadata_variousArtist_get, _tunepimp.metadata_variousArtist_set)
    __swig_setmethods__["artistId"] = _tunepimp.metadata_artistId_set
    __swig_getmethods__["artistId"] = _tunepimp.metadata_artistId_get
    if _newclass:artistId = property(_tunepimp.metadata_artistId_get, _tunepimp.metadata_artistId_set)
    __swig_setmethods__["albumId"] = _tunepimp.metadata_albumId_set
    __swig_getmethods__["albumId"] = _tunepimp.metadata_albumId_get
    if _newclass:albumId = property(_tunepimp.metadata_albumId_get, _tunepimp.metadata_albumId_set)
    __swig_setmethods__["trackId"] = _tunepimp.metadata_trackId_set
    __swig_getmethods__["trackId"] = _tunepimp.metadata_trackId_get
    if _newclass:trackId = property(_tunepimp.metadata_trackId_get, _tunepimp.metadata_trackId_set)
    __swig_setmethods__["fileTrm"] = _tunepimp.metadata_fileTrm_set
    __swig_getmethods__["fileTrm"] = _tunepimp.metadata_fileTrm_get
    if _newclass:fileTrm = property(_tunepimp.metadata_fileTrm_get, _tunepimp.metadata_fileTrm_set)
    __swig_setmethods__["albumArtistId"] = _tunepimp.metadata_albumArtistId_set
    __swig_getmethods__["albumArtistId"] = _tunepimp.metadata_albumArtistId_get
    if _newclass:albumArtistId = property(_tunepimp.metadata_albumArtistId_get, _tunepimp.metadata_albumArtistId_set)
    __swig_setmethods__["duration"] = _tunepimp.metadata_duration_set
    __swig_getmethods__["duration"] = _tunepimp.metadata_duration_get
    if _newclass:duration = property(_tunepimp.metadata_duration_get, _tunepimp.metadata_duration_set)
    __swig_setmethods__["albumType"] = _tunepimp.metadata_albumType_set
    __swig_getmethods__["albumType"] = _tunepimp.metadata_albumType_get
    if _newclass:albumType = property(_tunepimp.metadata_albumType_get, _tunepimp.metadata_albumType_set)
    __swig_setmethods__["fileFormat"] = _tunepimp.metadata_fileFormat_set
    __swig_getmethods__["fileFormat"] = _tunepimp.metadata_fileFormat_get
    if _newclass:fileFormat = property(_tunepimp.metadata_fileFormat_get, _tunepimp.metadata_fileFormat_set)
    __swig_setmethods__["numTRMIds"] = _tunepimp.metadata_numTRMIds_set
    __swig_getmethods__["numTRMIds"] = _tunepimp.metadata_numTRMIds_get
    if _newclass:numTRMIds = property(_tunepimp.metadata_numTRMIds_get, _tunepimp.metadata_numTRMIds_set)
    def __init__(self, *args):
        _swig_setattr(self, metadata, 'this', _tunepimp.new_metadata(*args))
        _swig_setattr(self, metadata, 'thisown', 1)
    def __del__(self, destroy=_tunepimp.delete_metadata):
        try:
            if self.thisown: destroy(self)
        except: pass

class metadataPtr(metadata):
    def __init__(self, this):
        _swig_setattr(self, metadata, 'this', this)
        if not hasattr(self,"thisown"): _swig_setattr(self, metadata, 'thisown', 0)
        _swig_setattr(self, metadata,self.__class__,metadata)
_tunepimp.metadata_swigregister(metadataPtr)

class artistresult(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, artistresult, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, artistresult, name)
    def __repr__(self):
        return "<C artistresult instance at %s>" % (self.this,)
    __swig_setmethods__["relevance"] = _tunepimp.artistresult_relevance_set
    __swig_getmethods__["relevance"] = _tunepimp.artistresult_relevance_get
    if _newclass:relevance = property(_tunepimp.artistresult_relevance_get, _tunepimp.artistresult_relevance_set)
    __swig_setmethods__["name"] = _tunepimp.artistresult_name_set
    __swig_getmethods__["name"] = _tunepimp.artistresult_name_get
    if _newclass:name = property(_tunepimp.artistresult_name_get, _tunepimp.artistresult_name_set)
    __swig_setmethods__["sortName"] = _tunepimp.artistresult_sortName_set
    __swig_getmethods__["sortName"] = _tunepimp.artistresult_sortName_get
    if _newclass:sortName = property(_tunepimp.artistresult_sortName_get, _tunepimp.artistresult_sortName_set)
    __swig_setmethods__["id"] = _tunepimp.artistresult_id_set
    __swig_getmethods__["id"] = _tunepimp.artistresult_id_get
    if _newclass:id = property(_tunepimp.artistresult_id_get, _tunepimp.artistresult_id_set)
    def __init__(self, *args):
        _swig_setattr(self, artistresult, 'this', _tunepimp.new_artistresult(*args))
        _swig_setattr(self, artistresult, 'thisown', 1)
    def __del__(self, destroy=_tunepimp.delete_artistresult):
        try:
            if self.thisown: destroy(self)
        except: pass

class artistresultPtr(artistresult):
    def __init__(self, this):
        _swig_setattr(self, artistresult, 'this', this)
        if not hasattr(self,"thisown"): _swig_setattr(self, artistresult, 'thisown', 0)
        _swig_setattr(self, artistresult,self.__class__,artistresult)
_tunepimp.artistresult_swigregister(artistresultPtr)

class albumresult(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, albumresult, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, albumresult, name)
    def __repr__(self):
        return "<C albumresult instance at %s>" % (self.this,)
    __swig_setmethods__["relevance"] = _tunepimp.albumresult_relevance_set
    __swig_getmethods__["relevance"] = _tunepimp.albumresult_relevance_get
    if _newclass:relevance = property(_tunepimp.albumresult_relevance_get, _tunepimp.albumresult_relevance_set)
    __swig_setmethods__["name"] = _tunepimp.albumresult_name_set
    __swig_getmethods__["name"] = _tunepimp.albumresult_name_get
    if _newclass:name = property(_tunepimp.albumresult_name_get, _tunepimp.albumresult_name_set)
    __swig_setmethods__["id"] = _tunepimp.albumresult_id_set
    __swig_getmethods__["id"] = _tunepimp.albumresult_id_get
    if _newclass:id = property(_tunepimp.albumresult_id_get, _tunepimp.albumresult_id_set)
    __swig_setmethods__["numTracks"] = _tunepimp.albumresult_numTracks_set
    __swig_getmethods__["numTracks"] = _tunepimp.albumresult_numTracks_get
    if _newclass:numTracks = property(_tunepimp.albumresult_numTracks_get, _tunepimp.albumresult_numTracks_set)
    __swig_setmethods__["numCDIndexIds"] = _tunepimp.albumresult_numCDIndexIds_set
    __swig_getmethods__["numCDIndexIds"] = _tunepimp.albumresult_numCDIndexIds_get
    if _newclass:numCDIndexIds = property(_tunepimp.albumresult_numCDIndexIds_get, _tunepimp.albumresult_numCDIndexIds_set)
    __swig_setmethods__["isVA"] = _tunepimp.albumresult_isVA_set
    __swig_getmethods__["isVA"] = _tunepimp.albumresult_isVA_get
    if _newclass:isVA = property(_tunepimp.albumresult_isVA_get, _tunepimp.albumresult_isVA_set)
    __swig_setmethods__["status"] = _tunepimp.albumresult_status_set
    __swig_getmethods__["status"] = _tunepimp.albumresult_status_get
    if _newclass:status = property(_tunepimp.albumresult_status_get, _tunepimp.albumresult_status_set)
    __swig_setmethods__["type"] = _tunepimp.albumresult_type_set
    __swig_getmethods__["type"] = _tunepimp.albumresult_type_get
    if _newclass:type = property(_tunepimp.albumresult_type_get, _tunepimp.albumresult_type_set)
    __swig_setmethods__["artist"] = _tunepimp.albumresult_artist_set
    __swig_getmethods__["artist"] = _tunepimp.albumresult_artist_get
    if _newclass:artist = property(_tunepimp.albumresult_artist_get, _tunepimp.albumresult_artist_set)
    def __init__(self, *args):
        _swig_setattr(self, albumresult, 'this', _tunepimp.new_albumresult(*args))
        _swig_setattr(self, albumresult, 'thisown', 1)
    def __del__(self, destroy=_tunepimp.delete_albumresult):
        try:
            if self.thisown: destroy(self)
        except: pass

class albumresultPtr(albumresult):
    def __init__(self, this):
        _swig_setattr(self, albumresult, 'this', this)
        if not hasattr(self,"thisown"): _swig_setattr(self, albumresult, 'thisown', 0)
        _swig_setattr(self, albumresult,self.__class__,albumresult)
_tunepimp.albumresult_swigregister(albumresultPtr)

class albumtrackresult(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, albumtrackresult, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, albumtrackresult, name)
    def __repr__(self):
        return "<C albumtrackresult instance at %s>" % (self.this,)
    __swig_setmethods__["relevance"] = _tunepimp.albumtrackresult_relevance_set
    __swig_getmethods__["relevance"] = _tunepimp.albumtrackresult_relevance_get
    if _newclass:relevance = property(_tunepimp.albumtrackresult_relevance_get, _tunepimp.albumtrackresult_relevance_set)
    __swig_setmethods__["name"] = _tunepimp.albumtrackresult_name_set
    __swig_getmethods__["name"] = _tunepimp.albumtrackresult_name_get
    if _newclass:name = property(_tunepimp.albumtrackresult_name_get, _tunepimp.albumtrackresult_name_set)
    __swig_setmethods__["id"] = _tunepimp.albumtrackresult_id_set
    __swig_getmethods__["id"] = _tunepimp.albumtrackresult_id_get
    if _newclass:id = property(_tunepimp.albumtrackresult_id_get, _tunepimp.albumtrackresult_id_set)
    __swig_setmethods__["numTRMIds"] = _tunepimp.albumtrackresult_numTRMIds_set
    __swig_getmethods__["numTRMIds"] = _tunepimp.albumtrackresult_numTRMIds_get
    if _newclass:numTRMIds = property(_tunepimp.albumtrackresult_numTRMIds_get, _tunepimp.albumtrackresult_numTRMIds_set)
    __swig_setmethods__["trackNum"] = _tunepimp.albumtrackresult_trackNum_set
    __swig_getmethods__["trackNum"] = _tunepimp.albumtrackresult_trackNum_get
    if _newclass:trackNum = property(_tunepimp.albumtrackresult_trackNum_get, _tunepimp.albumtrackresult_trackNum_set)
    __swig_setmethods__["duration"] = _tunepimp.albumtrackresult_duration_set
    __swig_getmethods__["duration"] = _tunepimp.albumtrackresult_duration_get
    if _newclass:duration = property(_tunepimp.albumtrackresult_duration_get, _tunepimp.albumtrackresult_duration_set)
    __swig_setmethods__["artist"] = _tunepimp.albumtrackresult_artist_set
    __swig_getmethods__["artist"] = _tunepimp.albumtrackresult_artist_get
    if _newclass:artist = property(_tunepimp.albumtrackresult_artist_get, _tunepimp.albumtrackresult_artist_set)
    __swig_setmethods__["album"] = _tunepimp.albumtrackresult_album_set
    __swig_getmethods__["album"] = _tunepimp.albumtrackresult_album_get
    if _newclass:album = property(_tunepimp.albumtrackresult_album_get, _tunepimp.albumtrackresult_album_set)
    def __init__(self, *args):
        _swig_setattr(self, albumtrackresult, 'this', _tunepimp.new_albumtrackresult(*args))
        _swig_setattr(self, albumtrackresult, 'thisown', 1)
    def __del__(self, destroy=_tunepimp.delete_albumtrackresult):
        try:
            if self.thisown: destroy(self)
        except: pass

class albumtrackresultPtr(albumtrackresult):
    def __init__(self, this):
        _swig_setattr(self, albumtrackresult, 'this', this)
        if not hasattr(self,"thisown"): _swig_setattr(self, albumtrackresult, 'thisown', 0)
        _swig_setattr(self, albumtrackresult,self.__class__,albumtrackresult)
_tunepimp.albumtrackresult_swigregister(albumtrackresultPtr)


New = _tunepimp.New

Delete = _tunepimp.Delete

GetVersion = _tunepimp.GetVersion

SetUserInfo = _tunepimp.SetUserInfo

GetUserInfo = _tunepimp.GetUserInfo

SetUseUTF8 = _tunepimp.SetUseUTF8

GetUseUTF8 = _tunepimp.GetUseUTF8

SetServer = _tunepimp.SetServer

GetServer = _tunepimp.GetServer

SetProxy = _tunepimp.SetProxy

GetProxy = _tunepimp.GetProxy

GetNumSupportedExtensions = _tunepimp.GetNumSupportedExtensions

GetSupportedExtensions = _tunepimp.GetSupportedExtensions

SetAnalyzerPriority = _tunepimp.SetAnalyzerPriority

GetAnalyzerPriority = _tunepimp.GetAnalyzerPriority

SetAutoFileLookup = _tunepimp.SetAutoFileLookup

GetAutoFileLookup = _tunepimp.GetAutoFileLookup

GetNotification = _tunepimp.GetNotification

GetStatus = _tunepimp.GetStatus

GetError = _tunepimp.GetError

SetDebug = _tunepimp.SetDebug

GetDebug = _tunepimp.GetDebug

AddFile = _tunepimp.AddFile

AddDir = _tunepimp.AddDir

Remove = _tunepimp.Remove

GetNumFiles = _tunepimp.GetNumFiles

GetNumUnsubmitted = _tunepimp.GetNumUnsubmitted

GetNumUnsavedItems = _tunepimp.GetNumUnsavedItems

GetTrackCounts = _tunepimp.GetTrackCounts

GetFileIds = _tunepimp.GetFileIds

GetTrack = _tunepimp.GetTrack

ReleaseTrack = _tunepimp.ReleaseTrack

Wake = _tunepimp.Wake

SelectResult = _tunepimp.SelectResult

Misidentified = _tunepimp.Misidentified

IdentifyAgain = _tunepimp.IdentifyAgain

WriteTags = _tunepimp.WriteTags

AddTRMSubmission = _tunepimp.AddTRMSubmission

SubmitTRMs = _tunepimp.SubmitTRMs

SetRenameFiles = _tunepimp.SetRenameFiles

GetRenameFiles = _tunepimp.GetRenameFiles

SetMoveFiles = _tunepimp.SetMoveFiles

GetMoveFiles = _tunepimp.GetMoveFiles

SetWriteID3v1 = _tunepimp.SetWriteID3v1

GetWriteID3v1 = _tunepimp.GetWriteID3v1

SetClearTags = _tunepimp.SetClearTags

GetClearTags = _tunepimp.GetClearTags

SetFileMask = _tunepimp.SetFileMask

GetFileMask = _tunepimp.GetFileMask

SetVariousFileMask = _tunepimp.SetVariousFileMask

GetVariousFileMask = _tunepimp.GetVariousFileMask

SetAllowedFileCharacters = _tunepimp.SetAllowedFileCharacters

GetAllowedFileCharacters = _tunepimp.GetAllowedFileCharacters

SetDestDir = _tunepimp.SetDestDir

GetDestDir = _tunepimp.GetDestDir

SetTopSrcDir = _tunepimp.SetTopSrcDir

GetTopSrcDir = _tunepimp.GetTopSrcDir

SetTRMCollisionThreshold = _tunepimp.SetTRMCollisionThreshold

GetTRMCollisionThreshold = _tunepimp.GetTRMCollisionThreshold

SetMinTRMThreshold = _tunepimp.SetMinTRMThreshold

GetMinTRMThreshold = _tunepimp.GetMinTRMThreshold

SetAutoSaveThreshold = _tunepimp.SetAutoSaveThreshold

GetAutoSaveThreshold = _tunepimp.GetAutoSaveThreshold

SetMaxFileNameLen = _tunepimp.SetMaxFileNameLen

GetMaxFileNameLen = _tunepimp.GetMaxFileNameLen

SetAutoRemovedSavedFiles = _tunepimp.SetAutoRemovedSavedFiles

GetAutoRemovedSavedFiles = _tunepimp.GetAutoRemovedSavedFiles

GetRecognizedFileList = _tunepimp.GetRecognizedFileList

DeleteRecognizedFileList = _tunepimp.DeleteRecognizedFileList

GetTrackStatus = _tunepimp.GetTrackStatus

SetTrackStatus = _tunepimp.SetTrackStatus

GetFileName = _tunepimp.GetFileName

GetTRM = _tunepimp.GetTRM

GetLocalMetadata = _tunepimp.GetLocalMetadata

SetLocalMetadata = _tunepimp.SetLocalMetadata

GetServerMetadata = _tunepimp.GetServerMetadata

SetServerMetadata = _tunepimp.SetServerMetadata

GetTrackError = _tunepimp.GetTrackError

GetSimilarity = _tunepimp.GetSimilarity

HasChanged = _tunepimp.HasChanged

GetResults = _tunepimp.GetResults

Lock = _tunepimp.Lock

Unlock = _tunepimp.Unlock

MetadataNew = _tunepimp.MetadataNew

MetadataDelete = _tunepimp.MetadataDelete

Clear = _tunepimp.Clear

ConvertToAlbumStatus = _tunepimp.ConvertToAlbumStatus

ConvertToAlbumType = _tunepimp.ConvertToAlbumType

ConvertFromAlbumStatus = _tunepimp.ConvertFromAlbumStatus

ConvertFromAlbumType = _tunepimp.ConvertFromAlbumType
